// GENERATED CODE - DO NOT MODIFY BY HAND

part of 'json_rpc_codegen_builder_example.dart';

// **************************************************************************
// JsonRpcGenerator
// **************************************************************************

// ignore_for_file: type=lint, unused_element

mixin SampleApiClientMixin on ClientBase {
  void hello(
    String name, [
    int? times,
    double? interval,
    int? delay,
  ]) {
    if (times == null && (interval != null || delay != null)) {
      throw ArgumentError(
        'Cannot set optional value to null if any of the following parameters (delay, interval) are not null.',
        'times',
      );
    }
    if (interval == null && (delay != null)) {
      throw ArgumentError(
        'Cannot set optional value to null if any of the following parameters (delay) are not null.',
        'interval',
      );
    }
    jsonRpcInstance.sendNotification(
      'hello',
      <dynamic>[
        name,
        if (times != null) times,
        if (interval != null) interval,
        if (delay != null) delay,
      ],
    );
  }

  void notify({
    required int id,
    List<double> measures = const [1, 2],
  }) =>
      jsonRpcInstance.sendNotification(
        'notify',
        <String, dynamic>{
          'id': id,
          'measures': measures,
        },
      );
  Future<String> echo(String message) async {
    final dynamic $result = await jsonRpcInstance.sendRequest(
      'echo',
      <dynamic>[message],
    );
    return ($result as String);
  }

  Future<User?> createUser(Map<String, Set<Permission>?> permissions) async {
    final dynamic $result = await jsonRpcInstance.sendRequest(
      'createUser',
      <dynamic>[
        permissions.map((
          $k,
          $v,
        ) =>
            MapEntry(
              $k,
              $v?.map(($e) => $e.name).toList(growable: false),
            ))
      ],
    );
    return _$maybeMap(
      $result,
      ($v) => User.fromJson(($v as Map<String, dynamic>)),
    );
  }

  Future<List<List<User>?>> userMatrix([Permission? permission]) async {
    final dynamic $result = await jsonRpcInstance.sendRequest(
      'userMatrix',
      <dynamic>[if (permission != null) permission.name],
    );
    return ($result as List)
        .map((dynamic $e) => ($e as List?)
            ?.map((dynamic $e) => User.fromJson(($e as Map<String, dynamic>)))
            .toList())
        .toList();
  }

  Future<Map<String, List<Permission>>> permissions() async {
    final dynamic $result = await jsonRpcInstance.sendRequest('permissions');
    return ($result as Map).map((
      dynamic $k,
      dynamic $v,
    ) =>
        MapEntry(
          ($k as String),
          ($v as List)
              .map((dynamic $e) => Permission.values.byName(($e as String)))
              .toList(),
        ));
  }

  Future<void> setHomepage({
    required Uri url,
    DateTime? timestamp,
  }) async =>
      jsonRpcInstance.sendRequest(
        'setHomepage',
        <String, dynamic>{
          'url': url.toString(),
          if (timestamp != null) 'timestamp': timestamp.toIso8601String(),
        },
      );
  Future<Uri> findForDates(Iterable<DateTime> times) async {
    final dynamic $result = await jsonRpcInstance.sendRequest(
      'findForDates',
      <dynamic>[
        times.map(($e) => $e.toIso8601String()).toList(growable: false)
      ],
    );
    return Uri.parse(($result as String));
  }

  void log(
    String message,
    dynamic context, [
    User user = const User('admin', 'admin'),
  ]) =>
      jsonRpcInstance.sendNotification(
        'log',
        <dynamic>[
          message,
          context,
          user,
        ],
      );
  Future<bool> validate({
    User? user,
    required User? authorizeFor,
    Permission? permission,
    List<Uri>? resources,
  }) async {
    final dynamic $result = await jsonRpcInstance.sendRequest(
      'validate',
      <String, dynamic>{
        if (user != null) 'user': user,
        'authorizeFor': authorizeFor,
        if (permission != null) 'permission': permission.name,
        if (resources != null)
          'resources':
              resources.map(($e) => $e.toString()).toList(growable: false),
      },
    );
    return ($result as bool);
  }

  Future<Map<dynamic, dynamic>> merge(
    Set<dynamic> keys,
    Iterable<dynamic> values,
  ) async {
    final dynamic $result = await jsonRpcInstance.sendRequest(
      'merge',
      <dynamic>[
        keys.toList(growable: false),
        values.toList(growable: false),
      ],
    );
    return ($result as Map);
  }

  Future<(int, List<User>?, Permission, (int, int))> flip(
    ({int am, Permission pm, (int, int) pt, List<User>? ul}) record,
    () control,
  ) async {
    final dynamic $result = await jsonRpcInstance.sendRequest(
      'flip',
      <dynamic>[
        <String, dynamic>{
          'am': record.am,
          'pm': record.pm.name,
          'pt': <dynamic>[
            record.pt.$1,
            record.pt.$2,
          ],
          'ul': record.ul,
        },
        <dynamic>[],
      ],
    );
    return _$map(
      ($result as List),
      ($v) => (
        ($v[0] as int),
        ($v[1] as List?)
            ?.map((dynamic $e) => User.fromJson(($e as Map<String, dynamic>)))
            .toList(),
        Permission.values.byName(($v[2] as String)),
        _$map(
          ($v[3] as List),
          ($v) => (($v[0] as int), ($v[1] as int)),
        )
      ),
    );
  }

  void startServerTask({
    required int id,
    required String taskName,
    bool? verbose,
    double? scale,
  }) =>
      jsonRpcInstance.sendNotification(
        'startServerTask',
        <String, dynamic>{
          'id': id,
          'taskName': taskName,
          if (verbose != null) 'verbose': verbose,
          if (scale != null) 'scale': scale,
        },
      );
  Future<double> getProgress(
    int id, [
    Stage stage = Stage.all,
  ]) async {
    final dynamic $result = await jsonRpcInstance.sendRequest(
      'getProgress',
      <dynamic>[
        id,
        stage.name,
      ],
    );
    return ($result as double);
  }
}
mixin SampleApiServerMixin on ServerBase {
  @protected
  FutureOr<void> hello(
    String name,
    int times,
    double? interval,
    int delay,
  );
  @protected
  FutureOr<void> notify(
    int id,
    List<double> measures,
  );
  @protected
  FutureOr<String> echo(String message);
  @protected
  FutureOr<User?> createUser(Map<String, Set<Permission>?> permissions);
  @protected
  FutureOr<List<List<User>?>> userMatrix(Permission? permission);
  @protected
  FutureOr<Map<String, List<Permission>>> permissions();
  @protected
  FutureOr<void> setHomepage(
    Uri url,
    DateTime? timestamp,
  );
  @protected
  FutureOr<Uri> findForDates(Iterable<DateTime> times);
  @protected
  FutureOr<void> log(
    String message,
    dynamic context,
    User user,
  );
  @protected
  FutureOr<bool> validate(
    User user,
    User? authorizeFor,
    Permission permission,
    List<Uri>? resources,
  );
  @protected
  FutureOr<Map<dynamic, dynamic>> merge(
    Set<dynamic> keys,
    Iterable<dynamic> values,
  );
  @protected
  FutureOr<(int, List<User>?, Permission, (int, int))> flip(
    ({int am, Permission pm, (int, int) pt, List<User>? ul}) record,
    () control,
  );
  @protected
  FutureOr<void> startServerTask(
    int id,
    String taskName,
    bool verbose,
    double? scale,
  );
  @protected
  FutureOr<double> getProgress(
    int id,
    Stage stage,
  );
  @override
  @visibleForOverriding
  @mustCallSuper
  void registerMethods() {
    super.registerMethods();
    jsonRpcInstance.registerMethod(
      'hello',
      (Parameters $params) async {
        final $$name = $params[0].asString;
        final $$times = $params[1].asIntOr(5);
        final $$interval =
            $params[2].$maybeNullOr(($v) => $v.asNum)?.toDouble();
        final $$delay = $params[3].asIntOr(100);
        await hello(
          $$name,
          $$times,
          $$interval,
          $$delay,
        );
      },
    );
    jsonRpcInstance.registerMethod(
      'notify',
      (Parameters $params) async {
        final $$id = $params['id'].asInt;
        final $$measures = $params['measures']
            .asList
            .map((dynamic $e) => ($e as double))
            .toList();
        await notify(
          $$id,
          $$measures,
        );
      },
    );
    jsonRpcInstance.registerMethod(
      'echo',
      (Parameters $params) async {
        final $$message = $params[0].asString;
        return (await echo($$message));
      },
    );
    jsonRpcInstance.registerMethod(
      'createUser',
      (Parameters $params) async {
        final $$permissions = $params[0].asMap.map((
              dynamic $k,
              dynamic $v,
            ) =>
                MapEntry(
                  ($k as String),
                  ($v as List?)
                      ?.map((dynamic $e) =>
                          Permission.values.byName(($e as String)))
                      .toSet(),
                ));
        return (await createUser($$permissions));
      },
    );
    jsonRpcInstance.registerMethod(
      'userMatrix',
      (Parameters $params) async {
        final $$permission = $params[0]
            .$maybeNullOr(($v) => Permission.values.byName($v.asString));
        return (await userMatrix($$permission));
      },
    );
    jsonRpcInstance.registerMethod(
      'permissions',
      () async {
        return (await permissions()).map((
          $k,
          $v,
        ) =>
            MapEntry(
              $k,
              $v.map(($e) => $e.name).toList(growable: false),
            ));
      },
    );
    jsonRpcInstance.registerMethod(
      'setHomepage',
      (Parameters $params) async {
        final $$url = $params['url'].asUri;
        final $$timestamp =
            $params['timestamp'].$maybeNullOr(($v) => $v.asDateTime);
        await setHomepage(
          $$url,
          $$timestamp,
        );
      },
    );
    jsonRpcInstance.registerMethod(
      'findForDates',
      (Parameters $params) async {
        final $$times = $params[0]
            .asList
            .map((dynamic $e) => DateTime.parse(($e as String)));
        return (await findForDates($$times)).toString();
      },
    );
    jsonRpcInstance.registerMethod(
      'log',
      (Parameters $params) async {
        final $$message = $params[0].asString;
        final $$context = $params[1].value;
        final $$user =
            User.fromJson(($params[2].value as Map<String, dynamic>));
        await log(
          $$message,
          $$context,
          $$user,
        );
      },
    );
    jsonRpcInstance.registerMethod(
      'validate',
      (Parameters $params) async {
        final $$user = $params['user'].$maybeOr(
          ($v) => User.fromJson(($v.value as Map<String, dynamic>)),
          const User('admin', 'admin'),
        );
        final $$authorizeFor = $params['authorizeFor']
            .$nullOr(($v) => User.fromJson(($v.value as Map<String, dynamic>)));
        final $$permission = $params['permission'].$maybeOr(
          ($v) => Permission.values.byName($v.asString),
          Permission.administrate,
        );
        final $$resources = $params['resources'].$maybeNullOr(($v) =>
            $v.asList.map((dynamic $e) => Uri.parse(($e as String))).toList());
        return (await validate(
          $$user,
          $$authorizeFor,
          $$permission,
          $$resources,
        ));
      },
    );
    jsonRpcInstance.registerMethod(
      'merge',
      (Parameters $params) async {
        final $$keys = $params[0].asList.toSet();
        final $$values = $params[1].asList;
        return (await merge(
          $$keys,
          $$values,
        ));
      },
    );
    jsonRpcInstance.registerMethod(
      'flip',
      (Parameters $params) async {
        final $$record = _$map(
          $params[0].asMap,
          ($v) => (
            am: ($v['am'] as int),
            pm: Permission.values.byName(($v['pm'] as String)),
            pt: _$map(
              ($v['pt'] as List),
              ($v) => (($v[0] as int), ($v[1] as int)),
            ),
            ul: ($v['ul'] as List?)
                ?.map(
                    (dynamic $e) => User.fromJson(($e as Map<String, dynamic>)))
                .toList()
          ),
        );
        final $$control = _$map(
          $params[1].asList,
          ($v) => (),
        );
        final $result = await flip(
          $$record,
          $$control,
        );
        return <dynamic>[
          $result.$1,
          $result.$2,
          $result.$3.name,
          <dynamic>[
            $result.$4.$1,
            $result.$4.$2,
          ],
        ];
      },
    );
    jsonRpcInstance.registerMethod(
      'startServerTask',
      (Parameters $params) async {
        final $$id = $params['id'].asInt;
        final $$taskName = $params['taskName'].asString;
        final $$verbose = $params['verbose'].asBoolOr(false);
        final $$scale =
            $params['scale'].$maybeNullOr(($v) => $v.asNum)?.toDouble();
        await startServerTask(
          $$id,
          $$taskName,
          $$verbose,
          $$scale,
        );
      },
    );
    jsonRpcInstance.registerMethod(
      'getProgress',
      (Parameters $params) async {
        final $$id = $params[0].asInt;
        final $$stage = Stage.values.byName($params[1].asString);
        return (await getProgress(
          $$id,
          $$stage,
        ));
      },
    );
  }
}

class SampleApiClient extends ClientBase with SampleApiClientMixin {
  SampleApiClient(super.channel) : super();

  SampleApiClient.withoutJson(super.channel) : super.withoutJson();

  SampleApiClient.fromClient(super.jsonRpcInstance) : super.fromClient();
}

abstract class SampleApiServer extends ServerBase with SampleApiServerMixin {
  SampleApiServer(
    super.channel, {
    super.onUnhandledError,
    super.strictProtocolChecks,
  }) : super();

  SampleApiServer.withoutJson(
    super.channel, {
    super.onUnhandledError,
    super.strictProtocolChecks,
  }) : super.withoutJson();

  SampleApiServer.fromServer(super.jsonRpcInstance) : super.fromServer();
}

@pragma('vm:prefer-inline')
TConverted _$map<TConverted extends Object, TJson extends Object>(
  TJson $value,
  TConverted Function(TJson) $convert,
) =>
    $convert($value);
@pragma('vm:prefer-inline')
TConverted? _$maybeMap<TConverted extends Object, TJson extends Object>(
  TJson? $value,
  TConverted Function(TJson) $convert,
) =>
    $value == null ? null : $convert($value);

extension _$JsonRpc2ParameterExtensions on Parameter {
  @pragma('vm:prefer-inline')
  T $maybeOr<T>(
    T Function(Parameter) getter,
    T defaultValue,
  ) =>
      exists ? getter(this) : defaultValue;
  @pragma('vm:prefer-inline')
  T? $nullOr<T>(T Function(Parameter) getter) =>
      value != null ? getter(this) : null;
  @pragma('vm:prefer-inline')
  T? $maybeNullOr<T>(T Function(Parameter) getter) =>
      exists && value != null ? getter(this) : null;
}
